# Scénario GitLab « branches »

Pour mémoire, un document scenario_branches_utilisateurs.md doit être fourni aux apprenants.

Il reprend les instructions à réaliser à chaque étape.

Le présent document est destiné au formateur afin de le guider de manière efficace dans le suivi du scénario.

Trois cas d'utilisations sont déroulés
* use case idéal: une issue = une MR = une branche = un commit = un push = une PR
* use case rebasage:
* use case conflit:

## Préparation formation

### Création d'une copie du projet exercice_session3
* Aller à la page [du projet exercice_session3](https://forgemia.inra.fr:git-gitlab-paca/exercice_session3)
* Récupération du code (tgz) projet `git@forgemia.inra.fr:git-gitlab-paca/exercice_session3.git` et installation dans un nouveau répertoire local

* Création d'un nouveau projet dans un autre espace de nom (au choix)
  * Nouveau nom du projet: session3_labo
  * Description: démo session 3, pour groupe ... , date ...
  * Visibilité: private
  * casser le lien avec le projet source (fork relationship / relation de bifurcation) via general settings/ Advanced/ Fork relationship

### Configuration du nouveau projet
* Déclarer les membres en fonction des présents (Manage/Members), en rôle "developper"
* configuration à faire pour empêcher la modification de la branche "main" par les stagiaires:
    * bloquer qui peut modifier la branche main (settings/Merge request,Merge commit with semi-linear history )
    * repository / protected branch et sur main, bloquer les push (no one )


# Use case idéal

## (Formateur)
* Envoyer un mail aux utilisateurs présents avec le nom du projet à cloner et le lien vers le fichier scenario_branches_utilisareur.md.
* Création et affectation des issues à chaque utilisateur (script à venir pour automatiser cette action car c'est un peu long)
* Au passage, expliquer qu'il joue le rôle de chef de projet
* Il explique les règles de MR (pas sur main) et que ce sont des conventions à définir/appliquer dès le début du projet
* On choisi le modèle une branche main stable, et des branches par issues pour faire évoluer le code.

## (Formateur) démo de fusion et ménage
* montre le contenu de la fusion, les changements , les commits associés
* procède à une revue de code sur les changements proposés (option)
* valide la fusion
* déclenche la fusion
* s'il a le temps, fermeture de toutes les issues, ménage dans les branches et les MR en attente

# Use case conflit
Nous allons volontairement créer une situation de conflit, que Git va vous demander de régler.

Diapos ?

Un conflit apparait lorsque deux modifications ont été faite au même endroit dans un fichier.
Git ne sait pas choisir qu'elle est la version à retenir, il va donc vous inviter à résoudre le conflit vous même.

## (Formateur) Démo résolution de conflit
* Prise en charge de l'issue Partie2_Chapitre2_bis (création branche à faire avant le push de la branche de l'issue précédente)
* Activation de la fusion précédente sans pull (en local, main est en retard, ainsi que la branche de l'issue)
* récupération de la nouvelle branche en local
* Correction de l'erreur dans le même fichier texte
* commit
* push
* Connexion à la forge
* Activation de la demande de fusion
* Constat de l'impossibilité à cause d'un conflit (git ne sait pas choisir laquelle des deux versions conserver)
* On peut voir les marques du conflit depuis les outils de la forge
* On peut aussi (bonne pratique) gérer ce conflit localement

```bash
git switch Partie2_Chapitre2_bis
git fetch
git rebase origin/main
```
* lire les messages  retournés par git !!
* ouvrir le fichier en conflit dans un éditeur
* constater les marques de conflit
* corriger (choisir le code à conserver, supprimer l'autre, supprimer les marques de conflit)

```bash
git add .
git commit -m "Fix conflict on issue Partie2_Chapitre2_bis"
git rebase --continue
```
# Use case rebasage
On veut illustrer ici la fonctionnalité de rebasage, sans conflit.

Diapos:

## (Formateur) Création des issues
* Création des issues et affectation aux utilisateurs
* il s'en prévoit une pour lui, afin de faire la démo d'accompagnement


## (Formateur) Démo rebasage
* Constat que la troisième fusion ne peut être faite parce que le dépôt n'est plus à jour (il ne contient pas la fusion 2 par exemple)

* résolution du problème par rebasage (on embarque dans la branche locale )

```bash
git checkout issue3
git rebase origin/main
```
