# Scénario GitLab « branches »

# Présentation des principes des exercices
Un projet a été créé par le formateur et va servir de dépôt martyre.

Vous allez donc pouvoir récupérer ce projet, et y apporter des modifications.

Le projet en question contient plusieurs fichiers textes avec du contenu. En l'occurrence, il s'agit d'extraits racontant certains évènement de l'histoire de France.

Dans la vraie vie, vous y rencontreriez probabement du code informatique

Dans ces différents textes, des erreurs ont été faites volontairement.

Le jeu sera de les corriger, tout en adoptant les bonnes pratiques concernant l'usage des branches

La bonne pratique est ici de créer une issue (l'animateur s'en occupe) et à partir de cette issue chacun pourra créer une branche dans laquelle il va faire la correction. A la fin, il y a autant de branches que d'utilisateur et que d'issues. Chaque branche avec sa correction est ensuite proposée à la fusion (Merge request) dans la branche principale, nommée main

De manière générale, on rappelle que la branche main doit être la branche stable, c'est à dire celle qui porte le code le plus à jour et opérationnel.

## Les issues

Le formateur va créer les issues en direct. Les utilisateurs recevront des mails avec un lien vers l'issue dans la forge


## Récupération du projet (Diapo 20)
* Récupération du dépôt: le formateur vous a envoyé un mail avec l'adresse du projet sur lequel nous allons travailler. Cloner ce projet sur votre poste.
* Découvrez les fichiers avec votre éditeur préféré

# Prise en main

## Créer une branche à partir d'une issue (diapo 27)
* Créer une issue sur la forge (sujet: correction bug <nom d'utilisateur>)
* s'affecter l'issue
* cliquer sur le bouton "Create merge request"
* récupérer la branche sur votre poste
* modifier un fichier (n'importe lequel) et créer en un nouveau
* revenir sur main et constater l'absence des modifications


## gérer la branche (diapo 64)
1) basculer sur votre branche créée précédemment
1) la publier sur le dépôt distant
1) parcourir la nouvelle branche dans GitLab
1) faites le ménage
    1) supprimer la branche locale et distante
    1) supprimer le ticket


# Fusion sans conflit


## (Utilisateur) prendre en charge l'issue reçue (cf mail)
* ouverture de l'issue
* échange éventuel de commentaires avec le commanditaire de l'issue (formateur)
* création d'une MR et d'une branche sur la forge

* récupération de la nouvelle branche, en local
* Correction de l'erreur dans le fichier texte en question (cf contenu de l'issue)
* commit
* push
* Connexion à la forge
* Activation de la demande de fusion

* observent les mouvements sur la forge, les changements proposés dans le texte
* peuvent accepter la fusion
* ne peuvent pas effectuer la fusion car ils n'en ont pas les privilèges dans le contexte de la formation

## (Utilisateur) mise en conformité du dépôt local
* git checkout main  --> bascule sur la branche main
* git pull  --> mise à jour de la branche main dans le dépôt local
* A ce stade, tout le monde est synchro (même version de main pour tous)
* les branches et MR créées à l'occasion de ce premier exerice peuvent être jetées.


# Use case conflit
Nous allons volontairement créer une situation de conflit, que Git va vous demander de régler.

Diapos 64 à 66

Un conflit apparait lorsque deux modifications ont été faite au même endroit dans un fichier.
Git ne sait pas choisir qu'elle est la version à retenir, il va donc vous inviter à résoudre le conflit vous même.

## (Utilisateur) prend en charge l'issue reçue (cf mail)
* ouverture de l'issue
* échange éventuel de commentaires
* création d'une MR et d'une branche sur la forge

* récupération de la nouvelle branche, en local
* Correction de l'erreur dans le fichier texte en question
* éventuellement dialogue avec celui qui a signalé l'issue
* commit
* push
* Connexion à la forge
* Activation de la demande de fusion

Le formateur prend la main et fait la démo de résolution du conflit


# Use case rebasage
On veut illustrer ici la fonctionnalité de rebasage, sans conflit.

Une branche nécessite d'être rebasée lorsque la branche sur laquelle est elle basée (ici main) comporte des commits qu'elle ne connait pas.

Diapos: 72 à 80

## (Utilisateur) prend en charge l'issue reçue (cf mail)
* ouverture de l'issue
* échange éventuel de commentaires
* création d'une MR et d'une branche sur la forge
* option: possibilité d'ajouter un voisin en reviewer du travail qui sera fait

* récupération de la nouvelle branche (distante), en local
* Correction de l'erreur dans le fichier texte en question
* éventuellement dialogue avec celui qui a signalé l'issue
* commit
* push
* Connexion à la forge
* Activation de la demande de fusion

## (Utilisateur) mise en conformité du dépôt local
* git checkout main  --> bascule sur la branche main
* git pull  --> mise à jour de la branche main dans le dépôt local
* A ce stade, tout le monde est synchro (même version de main pour tous)
* les branches et MR créées à l'occasion de ce premier exerice peuvent être jetées.
